<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ReadOnlyZooKeeperServer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">ReadOnlyZooKeeperServer.java</span></div><h1>ReadOnlyZooKeeperServer.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import org.apache.zookeeper.jmx.MBeanRegistry;
import org.apache.zookeeper.server.DataTreeBean;
import org.apache.zookeeper.server.FinalRequestProcessor;
import org.apache.zookeeper.server.PrepRequestProcessor;
import org.apache.zookeeper.server.RequestProcessor;
import org.apache.zookeeper.server.ZKDatabase;
import org.apache.zookeeper.server.ZooKeeperServer;
import org.apache.zookeeper.server.ZooKeeperServerBean;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;

/**
 * A ZooKeeperServer which comes into play when peer is partitioned from the
 * majority. Handles read-only clients, but drops connections from not-read-only
 * ones.
 * &lt;p&gt;
 * The very first processor in the chain of request processors is a
 * ReadOnlyRequestProcessor which drops state-changing requests.
 */
public class ReadOnlyZooKeeperServer extends QuorumZooKeeperServer {

<span class="fc" id="L41">    private volatile boolean shutdown = false;</span>
    ReadOnlyZooKeeperServer(FileTxnSnapLog logFactory, QuorumPeer self,
            DataTreeBuilder treeBuilder, ZKDatabase zkDb) {
<span class="fc" id="L44">        super(logFactory, self.tickTime, self.minSessionTimeout, self.maxSessionTimeout,</span>
                treeBuilder, zkDb, self);
<span class="fc" id="L46">    }</span>

    @Override
    protected void setupRequestProcessors() {
<span class="fc" id="L50">        RequestProcessor finalProcessor = new FinalRequestProcessor(this);</span>
<span class="fc" id="L51">        RequestProcessor prepProcessor = new PrepRequestProcessor(this, finalProcessor);</span>
<span class="fc" id="L52">        ((PrepRequestProcessor) prepProcessor).start();</span>
<span class="fc" id="L53">        firstProcessor = new ReadOnlyRequestProcessor(this, prepProcessor);</span>
<span class="fc" id="L54">        ((ReadOnlyRequestProcessor) firstProcessor).start();</span>
<span class="fc" id="L55">    }</span>

    @Override
    public synchronized void startup() {
        // check to avoid startup follows shutdown
<span class="pc bpc" id="L60" title="1 of 2 branches missed.">        if (shutdown) {</span>
<span class="nc" id="L61">            LOG.warn(&quot;Not starting Read-only server as startup follows shutdown!&quot;);</span>
<span class="nc" id="L62">            return;</span>
        }
<span class="fc" id="L64">        registerJMX(new ReadOnlyBean(this), self.jmxLocalPeerBean);</span>
<span class="fc" id="L65">        super.startup();</span>
<span class="fc" id="L66">        self.cnxnFactory.setZooKeeperServer(this);</span>
<span class="fc" id="L67">        LOG.info(&quot;Read-only server started&quot;);</span>
<span class="fc" id="L68">    }</span>

    @Override
    protected void registerJMX() {
        // register with JMX
        try {
<span class="fc" id="L74">            jmxDataTreeBean = new DataTreeBean(getZKDatabase().getDataTree());</span>
<span class="fc" id="L75">            MBeanRegistry.getInstance().register(jmxDataTreeBean, jmxServerBean);</span>
<span class="nc" id="L76">        } catch (Exception e) {</span>
<span class="nc" id="L77">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="nc" id="L78">            jmxDataTreeBean = null;</span>
<span class="fc" id="L79">        }</span>
<span class="fc" id="L80">    }</span>

    public void registerJMX(ZooKeeperServerBean serverBean, LocalPeerBean localPeerBean) {
        // register with JMX
        try {
<span class="fc" id="L85">            jmxServerBean = serverBean;</span>
<span class="fc" id="L86">            MBeanRegistry.getInstance().register(serverBean, localPeerBean);</span>
<span class="nc" id="L87">        } catch (Exception e) {</span>
<span class="nc" id="L88">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="nc" id="L89">            jmxServerBean = null;</span>
<span class="fc" id="L90">        }</span>
<span class="fc" id="L91">    }</span>

    @Override
    protected void unregisterJMX() {
        // unregister from JMX
        try {
<span class="pc bpc" id="L97" title="1 of 2 branches missed.">            if (jmxDataTreeBean != null) {</span>
<span class="fc" id="L98">                MBeanRegistry.getInstance().unregister(jmxDataTreeBean);</span>
            }
<span class="nc" id="L100">        } catch (Exception e) {</span>
<span class="nc" id="L101">            LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="fc" id="L102">        }</span>
<span class="fc" id="L103">        jmxDataTreeBean = null;</span>
<span class="fc" id="L104">    }</span>

    protected void unregisterJMX(ZooKeeperServer zks) {
        // unregister from JMX
        try {
<span class="pc bpc" id="L109" title="1 of 2 branches missed.">            if (jmxServerBean != null) {</span>
<span class="fc" id="L110">                MBeanRegistry.getInstance().unregister(jmxServerBean);</span>
            }
<span class="nc" id="L112">        } catch (Exception e) {</span>
<span class="nc" id="L113">            LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="fc" id="L114">        }</span>
<span class="fc" id="L115">        jmxServerBean = null;</span>
<span class="fc" id="L116">    }</span>

    @Override
    public String getState() {
<span class="fc" id="L120">        return &quot;read-only&quot;;</span>
    }

    /**
     * Returns the id of the associated QuorumPeer, which will do for a unique
     * id of this server.
     */
    @Override
    public long getServerId() {
<span class="fc" id="L129">        return self.getId();</span>
    }

    @Override
    public synchronized void shutdown() {
<span class="fc bfc" id="L134" title="All 2 branches covered.">        if (!isRunning()) {</span>
<span class="fc" id="L135">            LOG.debug(&quot;ZooKeeper server is not running, so not proceeding to shutdown!&quot;);</span>
<span class="fc" id="L136">            return;</span>
        }
<span class="fc" id="L138">        shutdown = true;</span>
<span class="fc" id="L139">        unregisterJMX(this);</span>

        // set peer's server to null
<span class="fc" id="L142">        self.cnxnFactory.setZooKeeperServer(null);</span>
        // clear all the connections
<span class="fc" id="L144">        self.cnxnFactory.closeAll();</span>

        // shutdown the server itself
<span class="fc" id="L147">        super.shutdown();</span>
<span class="fc" id="L148">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>